/******************************************************************/
/*	しずくデモ / Cascade Demo
/* for v3.2 later
/******************************************************************/
/* 内蔵フォントを使うので、全角文字もOK
// 全機種対応

enum
	LNG	=5		:/* 滴の最大長さ / max length of cascade
endenum

/* 内部キャラクター / internal character
enum
	WALL='#'	:/* 外壁 / wall
	BALL='o'	:/* 滴   / drop
	TANA='='	:/* 棚	 / shelf
	SPC =' '    :/* 空間 / space
endenum

int dx,dy	:/* 移動方向 / move direction
int clng	:/* 動作中ポインター / move pointer
int	retY	:/* X-BASICレベルでは2つのリターン値を戻せないのでグローバル変数を経由する
			 /* second return value is returned via the global variable

dim int drpx(LNG)		:/* 移動ｘ座標バッファー / move x position buffer
dim int drpy(LNG)		:/* 移動ｙ座標バッファー / move y position buffer
dim char tvram(96,96)	:/* 仮想ＶＲＡＭ / virtual video RAM
						:/* 機種によってサイズが可変なので、最大値で確保しておく
						:/* Size is variable depending on the model, It set aside the maximum value.

int	wtt		:/* ウエイト / wait

int WX
int WY
int MAX		:/* 棚の本数    / number of shelves

/******************************************************************/
/* メインルーチン / main routine
/******************************************************************/

width(64)
switch deviceType()
	case DEVICE_IPODTOUCH: // iPod touch
	case DEVICE_IPHONE: // iPhone
	case DEVICE_IPHONE_SIMURATOR
		width(40,30)
endswitch

getWidth(WX,WY):// システムの設定したテキスト画面サイズを得る / get text screen size(system set)
setUpScroll(NO):// テキスト画面の上スクロールを止める / disable to up scroll
WX=WX/2
MAX=(WX*WY/13)
int ts,t
/*int c
	srand2() /* 乱数初期化 / random initialize
	wtt=CalcWait()/100*8:/* ウエイト算出(8ms) / calc wait time (8ms)
	repeat
		InitScreen()	:/* 画面初期化 / screen initialize
		if Cascades() then break:/* 滴移動 / move cascade
		beep()
		locate(8,7)
		if isLocalizeJapan() then {
			print "もう一度見ますか？ ";
		} else {
			print "Watch again ?";
		}
	/*	c='Y';
		ts =time()
		repeat:/* 15秒たったら自動的に再開する / automatic repeat after 15 seconds
			t=time()
		until t-ts>=15
	until NO	:/*(c<>'Y' && c<>CR)
end

/******************************************************************/
/* 以下内部関数 / below are internal functions
/******************************************************************/

func InitScreen()
/* 初期画面作成 / make initial screen
int i,j,x,y
	cls()
	print "　　ＣＡＳＣＡＤＥＳ"
	init_tvram()

	/* 外枠作成 / make outside wall
	for y=1 to WY-2:/* 縦 / vertical
		storexy(   0,y,WALL)
		storexy(WX-1,y,WALL)
	next
	for x=0 to WX-1:/* 横 / horizontal
		storexy(x,WY-1,WALL)
	next

	/* 棚作成 / make shelf
	for i=0 to MAX-1
		x=1+rand2(WX-2) :/* 両端を除く / except both ends
		y=2+rand2(WY-3) :/* 一番上とその次と最下行を除く / Except for the bottom line and the top and the next
		for j=0 to 3
			if (x+j>=WX-1) then break /* x-over
			if (scrn(x+j,y)=SPC) then storexy(x+j,y,TANA)
		next
	next
	// 全画面一気表示 / full screen display
	printScreenAll(1,WY-1)
endfunc

/******************************************************************/

func int Cascades()
/* 滴処理 / cascade move
int x,y
//int ts=time():/* 開始時間 / start time
//int t,dt=0
	while CheckDropPoint()=0
		/* 開いているとき / if there is open
		/* 初期位置設定 / set initial position
		x=SetFirstPoint()
		y=1
		repeat
			//t=time()
			//if t-ts>dt then { :/* 秒が変った / change second
			//	dt=dt+1
			//	locate(30,0):print dt;
			//}
			//if inkey()=ESC then return(1)

			/* 移動＆表示 / move and display
			Drop(x,y)
			if clng=0 then break
			clng=clng-1
			x=drpx(clng)
			y=drpy(clng)
		until x=0 and y=0
	endwhile
	/* 最上行が開いていなかったら終わり / if top line is full then terminate
	return(0)
endfunc

/******************************************************************/

func int CheckDropPoint()
/* 最上行が開いているかどうかを調べる / check top line open
int x
	for x=1 to WX-2
		if scrn(x,1)=SPC then return(0) :/* 開いている / open
	next
	return(1) :/* 開いていない / close
endfunc

/******************************************************************/

func int SetFirstPoint()
/* スタートポイント設定（最上行）/ start point setting (top line)
int i,x
	x=1+rand2(WX-2):/* 始点決定 / set start point
	while scrn(x,1)<>SPC
		x=x+1
		if (x=WX-1) then x=1
	endwhile
	clng=LNG-1
	for i=0 to clng-1
		drpx(i)=0
		drpy(i)=0:/* 0=未記録の印 / 0=non record symbol
	next
	drpx(clng)=x
	drpy(clng)=1
	dx=0
	dy=1: /* 下へ / to down
	return(x)
endfunc

/******************************************************************/

func Drop(x;int,y;int)
/* 移動＆表示 / move and display
int r,l
	while (YES)
		/* 表示 / display
		printxy(x,y,BALL)
		TWait(wtt):/* ウエイト / wait
		
		/* 下が開いている？ / Is bottom open?
		if scrn(x,y+1)=SPC then {
			/* 無条件に下に落ちる / down fall
			dx=0
			dy=1
			x=Move(x,y)
			y=retY
			continue
		}
		
		/* 移動先チェック / check destination
		if scrn(x+dx,y+dy)=SPC then {
			/* 移動可能 / enable to move
			x=Move(x,y)
			y=retY
			continue
		}
		
		/* 移動先に移動できない時 / can't move the destination
		if (dy=1) then { :/* 下に落ちるはずだった時
			/* 左右チェック / check left and right
			r=(scrn(x+1,y)=SPC):/* 右
			l=(scrn(x-1,y)=SPC):/* 左
			
			/* 動けるなら左右移動に変更 / change left or right move if it can move
			dx=0
			if (r) then { :/* 右が開いている / right side is open
				dx=1
			}
			if (l) then { :/* 左が開いている / left side is open
				dx=-1
				if (r) then { :/* 右も開いている / right side is open too
					/* 左右どちらかを選ぶ / select left or right
					if rand2(2)=1 then dx=1
				}
			}
			if dx<>0 then {:/* 動ける時 / enable to  move
				dy=0
				x=Move(x,y)
				y=retY
				continue
			}
		}
		/* 動けないときはループ終了 / if can't move anywhere then loop out
		break
	endwhile
endfunc

/******************************************************************/

func int Move(x;int,y;int)
/* 移動＆消し / move and erase
int i
	if (drpy(0)<>0) then printxy(drpx(0),drpy(0),SPC):/* 前の場所を消す / erase previous position
	x=x+dx
	y=y+dy
	if (clng>=1) then {
		for i=1 to clng
			drpx(i-1)=drpx(i)
			drpy(i-1)=drpy(i)
		next
	}
	drpx(clng)=x
	drpy(clng)=y
	retY=y:/* 2つ目のリターン値はグローバル変数経由で返す / second return value is returned via the global variable
	return(x)
endfunc

/******************************************************************/
/* 仮想ＶＲＡＭシステム / virtual text VRAM system
/******************************************************************/

func str printChar$(c;char)
/* 表示文字取得 / get display characters
str c$
	switch (c)
		case SPC : c$= "　":break:/* 消す		erase
		case BALL: c$= "●":break :/* しずく	drops
		case WALL: c$= "■":break :/* 外壁	wall
		case TANA: c$= "□":break :/* 棚		shelf
	endswitch
	return (c$)
endfunc

func printxy(x;int,y;int,c;char)
/* 文字表示 / display characters
	/* 仮想ＶＲＡＭに出力 / output for virtual text VRAM
	tvram(x,y)=c

	/* 座標変換 / position transrate
	locate(x*2,y)
	
	/* キャラクター変換して表示 / display with character transrate
	print printChar$(c);
endfunc

func storexy(x;int,y;int,c;char)
/* 仮想ＶＲＡＭに出力 / output for virtual text VRAM
	tvram(x,y)=c
endfunc

func char scrn(x;int,y;int)
/* 仮想テキストＶＲＡＭを読み出す / read virtual text VRAM
	return(tvram(x,y))
endfunc

func printScreenAll(stY;int,edY;int)
/* 全画面一気表示 / full screen display
int x,y
str linestr
	for y=stY to edY
		linestr=""
		for x=0 to WX-1
			linestr=linestr+printChar$(tvram(x,y))
		next
		locate(0,y):print linestr;
	next
endfunc

func init_tvram()
/* 仮想テキストＶＲＡＭ初期化 / virtual text VRAM initialize
int x,y
	for y=0 to WY-1
		for x=0 to WX-1
			tvram(x,y)=SPC
		next
	next
endfunc

/******************************************************************/
/* 汎用関数
/******************************************************************/

func int CalcWait()
/* ウエイト量算出 / calc wait
int tim,tm
int count
	/* ０クロックチェック / Zero clock check
	tm=time()
	repeat
		tim=time()
	until tim-tm<>0
	count=0
	repeat
		tm=time()
		count=count+1
	until tm-tim<>0
	return(count):/* １秒に必要なカウント数 / count number per 1 second
endfunc

/******************************************************************/

func TWait(wt;int)
int i,tm
	for i=0 to wt-1
		tm=time()
	next
endfunc

/******************************************************************/
