// 楕円テスト / ellipse test
// for V3.20 later

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

float sx=50,cx,cy
float r=15
float hv
int i,j
//
vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)
apage(GPAGE0)
lineWidth(2)
enum
	FNTSZ=12
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
//
float wx=60,wy=60

hv=-2.0:// <0:横扁平
cx=sx:cy=50
for i=0 to (2/0.2)
	gColor(&h80000080)
	circle(cx,cy,r)
	gColor(&hff0000ff)
	ellipse(cx,cy,r,hv)
	symbol(cx-FNTSZ/4,cy+r+5,str$(hv),FONT,FNTSZ)
	cx=cx+wx
	if cx>=700 then cx=0:cy=cy+wy
	hv=hv+0.2:if hv>=-0.05 then hv=0:// 累積演算誤差対策
next

hv=0.0:// >0:縦扁平
cx=sx:cy=150
for i=0 to (2/0.2)
	gColor(&h80800080)
	circle(cx,cy,r)
	gColor(&hffff00ff)
	ellipse(cx,cy,r,hv,YES,&h5555)
	symbol(cx-FNTSZ/4,cy+r*(1+hv)+5,str$(hv),FONT,FNTSZ)
	cx=cx+wx
	if cx>=700 then cx=sx:cy=cy+wy
	hv=hv+0.2
next

// X68互換関数

// 横扁平
cx=sx:cy=250
for i=0 to 256
	circleX68(cx,cy,r,16387,0,360)
	circleX68(cx,cy,r,65535,0,360,i)
	symbol(cx-FNTSZ/4,cy+r+5,str$(i),FONT,FNTSZ)
	cx=cx+wx
	if cx>=700 then cx=sx:cy=cy+wy
	i=i+31:// 次のnextで+1
next

// 縦扁平

int col
cx=350:cy=440
r=120
if YES then {
col=16:// 最初に-1されるから
for i=256 to 3072
	if (i mod 256)=0 then col=col-1:if col=0 then col=15
	circle16X68(cx,cy,r,col,0,360,i)
//	wait(0.001)
next
}
cx=sx:cy=cy+r+30
r=15
for i=256 to 3072
	circleX68(cx,cy,r,16387,0,360)
	circleX68(cx,cy,r,65535,0,360,i)
	symbol(cx-FNTSZ/4,cy+r+5,str$(i),FONT,FNTSZ)
	cx=cx+wx
	if cx>=700 then cx=sx:cy=cy+wy
	i=i+128-1:// 次のnextで+1
next

end
