//------------------------------------------------
/* ファイルの一覧表示と削除を行うプログラム
/* 	サンプルのようでいて、実は実用プログラムである
/* File list display and delete program
/*	This is sample program and this is practical program actually.
//------------------------------------------------
// for v3.2 later
// 全機種対応

// 初期化 / initialize
font("IPAGothic")
int fzenhan
int WX=64:if deviceType()<>1 then WX=48
int WY=width(WX,,fzenhan)
int xw=1:/* 全角１文字の桁数 / double-width 1 character's columus
if fzenhan then xw=2

// タッチキー位置 / touch key area
int tx=WX-20:// <WX/2にすること
int ty=3
//
// 画面作成 / screen make
int lns=20:// 表示行数 / display lines
if lns>=WY-2 then lns=WY-2
makeScreen()
//
// 全ファイルリストを得る / get all file list
dim str fileList(256):// ()内は扱える最大ファイル数
int allcnt
str ext="":// 全ファイルを示す拡張子 / extension for all files
//
// 初期ファイル検索 / initial file search
int top:// 表示している先頭行要素番号:fileList(top)
		// 表示範囲は(top)〜(top+lns-1)
int cur:// カーソル位置:0〜lns-1
searchFiles(ext)
tcolor(-THWHITE,0,0,255)
tborder(2,200,0,0)
tBackgroundColor(0,0,200,200)
int ftest=0:// for test
//
repeat
	int top0=top,cur0=cur
	int fdel=NO
	str ext0=ext
	//
	int ky=inkey()
	switch ky
		// カーソル移動 / cursor move
		case '8'
			// カーソル上 / cursor up
			if cur=0 then {
				if top>0 then top=top-1
			} else {
				cur=cur-1
			}
			break
		case '2'
			// カーソル下 / cursor down
			if cur=lns-1 then {
				if top+lns<allcnt then top=top+1
			} else {
				if top+cur<allcnt-1 then cur=cur+1
			}
			break
		// ページ単位移動 / page move
		case '4'
			// 前ページ / prev. page
			if allcnt>lns then {
				// ページ切り替えが可能なとき / When paging is enabled
				top=top-(lns-1):// 1行残す / left 1 line
				if top<0 then top=0
			}
			break
		case '6'
			// 次ページ / next page
			if allcnt>lns then {
				// ページ切り替えが可能なとき / When paging is enabled
				top=top+(lns-1):// 1行残す / left 1 line
				if top+lns>allcnt then {
					top=allcnt-lns
				}
			}
			break

		// 削除 / delete
		case 'd'
			allcnt=allcnt-1
			str fname=fileList(top+cur)
			int ret
			str title$,errmes$
			dim str mn$(1)
			if isLocalizeJapan() then {
				mn$(0)="いいえ"
				mn$(1)="はい"
			} else {
				mn$(0)="NO"
				mn$(1)="YES"
			}
			if fname[strlen(fname)-1]='/' then {
				// ディレクトリだったとき
				if isLocalizeJapan() then {
					title$="このディレクトリを削除しますか？"
					errmes$="削除できません(空でない)"
				} else {
					title$="Delete this directory ?"
					errmes$="Can't delete(Not empty)"
				}
				if selectMenu(title$,mn$)=1 then {
					// ただし、空ディレクトリでないと削除できない
					if rmdir(fname)=0 then {
						fdel=YES:// 表示も変更が必要
					} else {
						messageDisp(errmes$+":"+fname)
					}
				}
			} else {
				// ファイルだった時
				if isLocalizeJapan() then {
					title$="このファイルを削除しますか？"+chr$(DISP_CTRL_LF)+fname
					errmes$="プログラムの削除はプログラム選択メニューで行ってください"
				} else {
					title$="Delete this file ?"
					errmes$="Please delete in program selection menu."
				}
				str ext2=pathExtension(fname)
				strlwr(ext2)
				if ext2="bas" then {
					// .basファイルは消せないようにしておく(プログラムを削除するのはプログラム選択メニューから)
					// Disable to delete .bas file (if you will do, do in program select menu)
					messageDisp(errmes$+chr$(13)+fname)
					break
				}
				if selectMenu(title$,mn$)=1 then {
					if fdelete(fname)=0 then {
						fdel=YES:// 表示も変更が必要
					} else {
						messageDisp(errmes$+":"+fname)
					}
				}
			}
			break
		
		// for test
		case 'T'
//			locate(0,1+lns):print "test=";ftest
			switch ftest
				case 0
					tBorder(2,0,200,0)
					break
				case 1
					tBackgroundColor(100,0,0,200)
					break
				case 2
					tBackgroundAlpha(0.5)
					break
				case 3:// 元に戻す
					tBackgroundColor(0,0,200,200)
					tborder(2,200,0,0)
					tBackgroundAlpha(1)
					break
				case 4
					kBackgroundAlpha(0.5)
					break
				case 5
					kBackgroundAlpha(1.0)
					break
			endswitch
			ftest=ftest+1
			if ftest>5 then ftest=0
			beep2(13)
			break

		// 拡張子変更 / change extension
		case 'j'
			ext="[jJ][pP][gG]"
			break
		case 'p'
			ext="[pP][nN][gG]"
			break
		case 'a'
			ext=""
			break

		default
			break
	endswitch
	if ext<>ext0 or fdel=YES then {
		// 拡張子変更 / extension changed
		// またはファイルの数が変わった / Or the number of files is changed
		// ファイルの再検索をする / File research
		int top1=top
		int cur1=cur
		searchFiles(ext)
		if top1+cur1>=allcnt then {
			// 範囲外を指すときは先頭に戻す
			top=0
			cur=0
		} else {
			// 新しいページにまだ収まるとき
			top=top1
			cur=cur1
		}
		// ページは変わらないけど、再表示は必要
		printList()
	}
	if top<>top0 then {
		// ページが変わる / page changed
		printList()
		fdel=NO
	} else {
		if cur<>cur0 then {
			// カーソル位置が変わった / cursor moved
			printList1(cur0) // 元の位置を反転解除 / non-reverse old position
			printList1(cur)	 // 新しい位置を反転 / revese new position
		}
	}
until ky='!'
end

//------------------------------------------------
// 関数 / functions
//------------------------------------------------

func printKeys(x;int,y;int,fdispOnly;int)
	dim int	touchNo(10)	:// タッチエリア番号 / touch area number
	int touchallcnt		:// タッチエリア数   / the number of touch area
	enum
		XC=4
		YC=1
	endenum
	int ky=(y+1)*32+8,kx=4
	int K1X=16*4,K1Y=16*4
	str dev=devicePlatform()
	if (left$(dev,4)<>"iPad") then {
		K1X=16*2
		K1Y=16*2
		kx=2
		ky=(y+1)*16-8
	}
	vpriority(GPAGE0,TPAGE,GPAGE1,GPAGE2,GPAGE3)
	vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)
	apage(GPAGE0)
	dim int keys( XC*YC-1)={'4','8','2','6'}
	dim str disps(XC*YC-1)={"<<","↑","↓",">>"}
	if (fdispOnly) then {
		setTouchKeys(kx,ky,XC,YC,K1X,K1Y,keys,disps,"Migu-1M-Regular"):// 再表示のみ
	} else {
		touchallcnt =setTouchKeys(kx,ky,XC,YC,K1X,K1Y,keys,disps,"Migu-1M-Regular",touchNo)
	}
endfunc

func makeScreen()
	// タッチキー / touch key
	int x=0
	int y=1+lns+1
	printKeys(x,y,NO)

	// ファンクションキー / fucntion key
	str exit$,ext$,prev$,next$,del$
	if isLocalizeJapan() then {
		exit$="終了"
		ext$="全て"
		prev$="前頁"
		next$="後頁"
		del$="削除"
	} else {
		exit$="exit"
		ext$="all"
		prev$="Prev"
		next$="Next"
		del$="Del"
	}
	setFunctionKey(0,prev$,'4')
	setFunctionKey(1,next$,'6')
	setFunctionKey(2,"   ",'?')
	setFunctionKey(3,del$ ,'d')
	setFunctionKey(4,"   ",'?')
	setFunctionKey(5,"jpg",'j')
	setFunctionKey(6,"png",'p')
	setFunctionKey(7,ext$ ,'a')
	setFunctionKey(8,"   ",'T')
	setFunctionKey(9,exit$,'!')

	setFunctionKeyBackgroundImage("funcBackW2.png")
	displayFunctionKeyAll(YES,YES)
endfunc

func messageDisp(mes;str)
if (YES) then {
	dim str menues(1)
	menues(0)=localizedString("確認","Confirm")
	selectMenu(mes,menues)
} else {
	locate(0,lns+1)
	if len(mes)=0 then {
		print chr$(DISP_CTRL_CLEARLINE) 
	} else {
		print mes
	}
}
endfunc

//------------------------------------------------

func printList1(i;int)
// 1行表示 / 1line display
	locate(0,1+i)
	if top+i<allcnt then {
		if i=cur then tatrb(ATRB_REVERSE):// 選択行 / selected line
		print using "###:";top+i;
		print fileList(top+i);
	//	print lastPathComponent(fileList(top+i));
		if i=cur then tatrb(ATRB_NORMAL)
	}
	print chr$(DISP_CTRL_CLEARLINE):// 行末まで消す / clear to end of line
endfunc

func printList()
// 画面内表示 / display in screen
	int i
	int max=lns
	for i=0 to max-1
		printList1(i)
	next
endfunc

func searchFiles(ext;str)
	// 新しく表示し直すので各種ポインターをリセット
	top=0	:// 表示している先頭行要素番号:fileList(top)
			 // 表示範囲は(top)〜(top+lns-1)
	cur=0	:// カーソル位置:0〜lns-1
	//
	// int files(pathes;文字列配列[,basedir;str][,ext;str][,fhave;int][,mode;int][,freg;int][,farea;int])
	allcnt=files(fileList,"",ext,YES,FILES_ALL,YES) :// ここはユーザー領域のみ / user area only
//	allcnt=files(fileList,"",ext,YES,FILES_ALL,YES) :// ここはユーザー領域のみ / user area only
	cls()
	printKeys(0,1+lns+1,YES)
	//
	locate(0,0)
	if isLocalizeJapan() then {
		print "拡張子=";ext,,
		print "ファイル数=";allcnt
	} else {
		print "extension=";ext,,
		print allcnt;" files"
	}
	printList()
endfunc

//------------------------------------------------
