//****************************************************************
/* 多角形の基本図形分割
/* Oh!X 1993/3
/* JAN. 19th 1993 by (ats)
//****************************************************************
// V3.00以降専用
// 多分全機種対応

enum
	MAX_POINT=100
endenum

dim px(MAX_POINT),py(MAX_POINT),conn(1,MAX_POINT),f(MAX_POINT)
dim float t(MAX_POINT,MAX_POINT),w(MAX_POINT,MAX_POINT)
dim float m(MAX_POINT)
int max=0,mx,my,maxc=0,t1,t2
float inf=10000

enum
	FNTSZ=16
	KEY_SPACE=' '
	KEY_SET	 ='s'
	KEY_DEL	 ='d'
	KEY_END	 ='e'
endenum
str FONT="Migu-1M-Regular"

initialize()

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim str menues(1)
str title$

	if isLocalizeJapan() then {
		title$=".poiファイルを読み込みますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Do you read from .poi file ?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0
			fin()
			break
		case 1:
			cut()
			break
	endswitch

	draw(max,2,2)
	ptrev()
	wcalc()
	print localizedString("すべての弦の距離を計算し終わりました。","Finish calculation of all strings.")
	tauclr()
	taucalc()
	print localizedString("これから分割を行います","Now start deviding.")
	divide()
	
	if isLocalizeJapan() then {
		title$="ファイルを書き出しますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Do you write to file ?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0
			fout()
			break
	endswitch
	
	apage(GPAGE0):bitmapClose()
end

//****************************************************************

func initialize()
	wipe()
	cls()
	setgPalet16X68(0,0)
	setgPalet16X68(1,rgbX68(30, 3, 0))
	setgPalet16X68(2,rgbX68( 0,30, 5))
	setgPalet16X68(3,rgbX68(31,31,31))
	setgPalet16X68(4,rgbX68( 3, 2,31))
endfunc

//****************************************************************

func divide()
/* 多角形を最適に分割する
int a,b,a2,b2
float tm=0,m1,m2
	repeat
		tm=taumin(tm)
		m1=wire(t1		,nxf(nxf(t1)))
		m2=wire(t1+t2-1	,nxb(nxb(t1+t2-1)))
		if m1< m2 then {
			a2=t1
			b2=nxf(nxf(t1))
		} else {
			b2=(t1+t2-1) mod max
			a2=nxb(nxb(t1+t2-1))
		}
		conn(0,maxc)=a2
		conn(1,maxc)=b2
		maxc=maxc+1
		line16X68(px(a2),py(a2),px(b2),py(b2),4)
		a=nxf(a2)
		f(a)=1
		circle16X68b(px(a),py(a),8,1)
		tref(a)
	until maxc=max-3
endfunc

//****************************************************************

func nxf(n)
int i,j
	for i=1 to max-1
		if f((n+i) mod max)=0 then {
			j=(n+i) mod max
			break
		}
	next
	return(j)
endfunc

//****************************************************************

func nxb(n)
int i,j 
	for i=1 to max-1
	if f((n-i+max) mod max)=0 then {
		j=(n-i+max) mod max
		break
	}
	next
	return(j)
endfunc

//****************************************************************

func tref(a)
int i,j
	for i=0 to max-1
		for j=0 to max-1
			if i=a or(i+j-1) mod max=a then {
				t(i,j)=t(i,j)+100000
			}
		next
	next
endfunc

//****************************************************************

func taucalc()
/* τを動的計画法に基づいて計算する
int i,j
	for j=4 to max
		for i=0 to max-1
			t(i,j)=tau(i,j)
		next
	next
endfunc

//****************************************************************

func float tau(i,j)
/* 本文中の漸化式を再帰的に求める
int k
	i=(i+max) mod max
	j=(j+max) mod max
	if wire(i,i+j-1)>=inf then {
		return(inf)
	}
	if t(i,j)<>-1 then {
		/* 値が計算済みである場合
		return(t(i,j))
	}
	mcl()
	m(0)=wire(i+1,i+j-1)+tau(i+1,j-1)
	m(1)=wire(i  ,i+j-2)+tau(i  ,j-1)
	for k=2 to j-1
		m(k)=wire(i,i+k-1)+wire(i+k-1,i+j-1)
		m(k)=m(k)+tau(i,k)+tau(i+k-1,j-k+1)
	next
	return(min(k))
endfunc

//****************************************************************

func float taumin(tm;float)
/* 配列t(i,j)の中から最小値を見つけて返す
int i,j
float mi=10000
	for i=0 to max-1
		for j=4 to max-1
			if tau(i,j)< mi and tau(i,j)>tm then {
				mi=tau(i,j)
				t1=i
				t2=j
			}
		next
	next
	t(t1,t2)=t(t1,t2)+90000
	return(mi)
endfunc

//****************************************************************

func float min(n)
/* m(n)の中から最小値を見つけ戻り値とする
int i
float minimam=100000
	for i=0 to n
		if minimam >m(i) then minimam=m(i)
	next
	return(minimam)
endfunc

//****************************************************************

func float wire(a,b)
/* ちょっとあこぎな関数かも。記述はきれいになるけど。
	return(w((a+max) mod max,(b+max) mod max))
endfunc

//****************************************************************

func tauclr()
int i,j
	for i=0 to MAX_POINT
		for j=4 to MAX_POINT
			t(i,j)=-1
		next
	next
endfunc

//****************************************************************

func mcl()
int i
	for i=0 to MAX_POINT
		m(i)=99999
	next
endfunc

//****************************************************************

func wcalc()
/* すべての対角線分のユークリッド距離を求める
int i,j,h,a,b,c
	for i=0 to max-1
		w(i,(i+1) mod max)=inf
		w((i+1) mod max,i)=inf
		for j=i+2 to max-1
			if incl(i,j)=0 then {
				w(i,j)=sqr(pow(px(i)-px(j),2)+pow(py(i)-py(j),2))
			} else {
				w(i,j)=inf
			}
			/* 弦が多角形内に含まれないなら距離を大きく取る
			w(j,i)=w(i,j)
		next
	next
endfunc

//****************************************************************

func incl(i,j)
/* 指定した弦が多角形内に含まれるかどうかを判定する
int a,b,c,d=0,h
	a=tsize(j-1,j,i  )
	b=tsize(i  ,j,j+1)
	c=tsize(j-1,j,j+1)
	if c >0 then {
		/* 「開き」が180度未満の場合
		if a<0 or  b<0 then d=-1
	} else {
		/* 「開き」が180度未満の場合
		if a<0 and b<0 then d=-1
	}
	if d=0 then {
		for h=0 to max-1
			a=tsize(i,j,h)*tsize(i,j,h+1)
			b=tsize(h,h+1,i)*tsize(h,h+1,j)
			if a< 0 and b< 0 then {
				d=-1
				break
			}
		next
	}
	return(d)
endfunc

//****************************************************************

func float tsize(a,b,c)
/* 三角形の符号付き面積の符号を求める
float ans
	a=(a+max) mod max
	b=(b+max) mod max
	c=(c+max) mod max
	ans=(px(a)-px(c))*(py(b)-py(c))
	ans=ans+(px(b)-px(c))*(py(c)-py(a))
	return(sgn(ans))
endfunc

//****************************************************************

func ptrev()
/* 座標の並びが反時計回りなら時計回りにする
int i,a,b
	if area(max)<>0 then {
		print localizedString("座標の並びが反時計回りなので反転します","Reverse the order of coordinates becase coordinates are counterclockwise rotation.")
		b=(max-1)/2
		for i=0 to b
			a=px(i):px(i)=px(max-1-i):px(max-1-i)=a
			a=py(i):py(i)=py(max-1-i):py(max-1-i)=a
		next
		wipe()
		draw(max,2,2)
	}
endfunc

//****************************************************************

func area(max)
/* 点が時計回りか確かめる
/* (注)グラフィック座標系ではｙ軸が反転している
int i,a=0,t=0
	for i=1 to max-2
		t=t+px(i)*(py(i+1)-py(i-1))
	next
	t=t+px(0)*(py(1)-py(max-1))
	t=t+px(max-1)*(py(0)-py(max-2))
	if t>0 then return(0)
	return(-1)
endfunc

//****************************************************************

func cut()
/* 多角形を切り出す
int a,b
	cls():wipe()
	setFunctionKey(0,""	,' ')
//	setFunctionKey(0,localizedString("頂点を登録","Set")	,KEY_SET)
	setFunctionKey(1,localizedString("頂点を削除","Delete")	,KEY_DEL)
	setFunctionKey(2,""	,' ')
	setFunctionKey(3,""	,' ')
	setFunctionKey(4,localizedString("切り出し終了","finish"),KEY_END)
	setFunctionKeyBackgroundImage("funcBackR2.png")
	displayFunctionKey(YES,0,4)

	if msopr()=1 then {
		px(0)=mx
		py(0)=my
		max=1
		mswait()
		box16X68(mx-1,my-1,mx+1,my+1,1)
	}
	repeat
		a=msopr()
		switch a
			case 1
				px(max)=mx
				py(max)=my
				box16X68(mx-1,my-1,mx+1,my+1,1)
				line16X68(px(max-1),py(max-1),mx,my,2)
				max=max+1
				np()
				mswait()
				break
			case 2
				max=max-1
				np()
				wipe()
				draw(max,2,0)
				mswait()
				break
		endswitch
	until a=3
	displayFunctionKey(NO,0,4)
endfunc

//****************************************************************

func msopr()
int a
int ky
	repeat
		while getTouchStatus()=TOUCH_NONE
			ky=inkey()
			if ky then break
		endwhile
		a=0
		switch ky
			case KEY_END
				if max< 4 then {
					locate(0,3)
					print localizedString("頂点は4つ以上指定してください","Please set over than 4 vertexes.")
					beep()
				} else {
					a=3
				}
				break
			case KEY_DEL
				if max=1 then {
					locate(0,3)
					print localizedString("この点ばかりは削除できません","This vertex can't delete.")
				} else {
					a=2
				}
				break
			default
				dim float tpoint(1)
				int touchCnt=getTouchPoint(tpoint)
				mx=tpoint(0)
				my=tpoint(1)
				a=1
				break
		endswitch
	until a<>0
	return(a)
endfunc

//****************************************************************

func mswait()
// タッチが離されるのを待つ
	repeat:until getTouchStatus()=TOUCH_NONE
endfunc

//****************************************************************

func np()
/* 頂点数を表示する
	locate(0,3)
	if isLocalizeJapan() then {
		print using "頂点数 ###";max
	} else {
		print using "The number of vertexes ###";max
	}
endfunc

//****************************************************************

func draw(max,col,mode)
/* 多角形を表示する
/* モード0: 多角形を閉じずに頂点を強調
/* 	  1: 閉じて頂点を強調
/* 	  2: 閉じて頂点を強調し、番号を表示
/* 	  3: 閉じて頂点は強調せず
int a,i
	for i=0 to max-2
		line16X68(px(i),py(i),px(i+1),py(i+1),col)
	next
	if mode<3 then {
		for i=0 to max-1
			box16X68(px(i)-1,py(i)-1,px(i)+1,py(i)+1,1)
		next
	}
	if mode=2 then {
		for i=0 to max-1
			symbol16X68(px(i)-3,py(i)-6,str$(i),0.9,3,FONT,FNTSZ)
		next
	}
	if mode<>0 then {
		line16X68(px(0),py(0),px(max-1),py(max-1),col)
	}
endfunc

//****************************************************************

func fout()
char a
str fn
	print localizedString("ファイル名を入力してください:","file name:");
	input fn
	fn=fn+".poi"
	int fp
	fp=fopen(fn,"c")
	if fopenError(fp) then {
		print localizedString("ファイルが作成できません:","File can't create:");fn
		end
	}
	a=max
	fputc(a,fp)
	fwrite(px,max,fp)
	fwrite(py,max,fp)
	fclose(fp)
endfunc

//****************************************************************

func fin()
char a
str fn
	print localizedString("ファイル名を入力してください:","file name:");
	input fn
	fn=fn+".poi"
	int fp
	fp=fopen(fn,"rw")
	if fopenError(fp) then {
		print localizedString("ファイルが見つかりません:","File not found:");fn
		end
	}
	a=fgetc(fp)
	max=a
	fread(px,max,fp)
	fread(py,max,fp)
	fclose(fp)
endfunc

//****************************************************************

func prput()
int i,j,h
	print
	print "   ";
	for i=0 to max-1
		print using "  ##   ";i;
	next
	print
	for i=0 to max-1
		print using "##:";i;
		for j=0 to max-1
			if w(j,i)>=inf then {
				print "  ∞  ";
			} else {
				print using "###.#  ";w(j,i);
			}
		next
		print
	next
	print "   ";
	for i=4 to max
		print using "  ##   ";i;
	next
	print
	for i=0 to max-1
		print using "##:";i;
		for j=4 to max
			if t(i,j)>=inf then {
				print "  ∞  ";
			} else {
				print using "###.## ";t(i,j);
			}
		next
		print
	next
endfunc

//****************************************************************
